Rails.application.routes.draw do
	locales = Site.find_by(site_active: true).in_use_locales rescue I18n.available_locales
	scope "(:locale)", locale: Regexp.new(locales.join("|")) do
		namespace :admin do
      get 'lab_setting' => "labs#setting"
      get 'labs/download_excel_format' => 'labs#excel_format'
      post 'labs/import_from_excel' => 'labs#import_from_excel'

      resources :labs do
        collection do
          get 'toggle_hide' => 'labs#toggle_hide'
          get 'analysis'
          get 'analysis_report'
          get "download_excel"
        end
      end

      resources :members do
        collection do
          scope '(:name-:uid)' do
            resources :labs do
              collection do
                get 'frontend_setting' => 'labs#frontend_setting'
                post 'update_frontend_setting' => 'labs#update_frontend_setting'
              end
            end
          end
        end
      end

		end
	end
end
